#include <stdio.h>
#include <string.h>

#include <signal.h>
                      
#include <linux/joystick.h>

  /* JoyConfig v0.9p, de El Presi (presi@euibbs.upv.es) */
  /* http://bbs.eui.upv.es/~presi/software/ */
  /* bajo licencia GPL, mas info: www.fsf.org */

void acabar(int sig);

FILE *fd,*fc;
                         
int main(int argc, char *argv[])
 {
   struct js_event e;
   char fico[256],disp[256],displ[256],comando[256];

   /* Interpretar opciones */

   if (argc==2 && argv[1][0]=='-')
    {
      if (argv[1][1]=='v'|| argv[1][1]=='V')
       {
         puts("joyconfig 0.9p");
         return 0;
       }
      if (argv[1][1]=='h' || argv[1][1]=='?')
       {
         puts("Utilizacion: joyconfig [fichero configuarcion]");
         return 0;
       }
    }

   puts("Joyconfig 0.9p by Presi (GPL)");

   /* Capturando y abriendo fichero de configuarcion */
  
   if (argc==1)
     {
       printf("Fichero de configuracion [/etc/joysh.conf]: ");
       gets(fico);
       if (fico[0]=='\0') strcpy(fico,"/etc/joysh.conf");
     }
   else strcpy(fico,argv[1]);
   
   if ( (fc = fopen(fico,"w"))==NULL )
     {
       fputs("joyconfig: no se ha podido abrir fichero configuracion\n",stderr);
       return 1;
     }

   /* Capturando fichero de dispositivo a incluir en la configuracion */
         
   printf("Dispositivo a incluir en fichero de configuracion [/dev/js0]: ");
   gets(disp);

   if (disp[0]=='\0') strcpy(disp,"/dev/js0");

   /* Capturando y abriendo fichero de dispositivo local del hardware actual */
   
   printf("Dispositivo local (donde esta ahora conectado el joystick) [%s]: ",disp);
   gets(displ);
   
   if (displ[0]=='\0') strcpy(displ,disp);
   
   if ( (fd = fopen(displ,"rb"))==NULL )
     {
       fputs("joyconfig: no se ha podido abrir fichero de dispositivo\n",stderr);
       return 1;
     }

   /* Capturando comando que ejecutara joysh */
   
   printf("Comando: ");
   gets(comando);

   /* Escribiendo cabecera fichero de configuracion */

   fputs("# Dispositivo\n",fc);
   fputs(disp,fc);
   
   fputs("\n# Comando a ejecutar\n",fc);
   fputs(comando,fc);
   
   fputs("\n# Secuencias\n",fc);

   /* --- */

   /* Leyendo secuencia inicial */

   puts("Haz un movimiento de joystick para iniciar secuencia");

   do fread(&e,sizeof(struct js_event),1,fd);
   while ( e.type==(JS_EVENT_BUTTON | JS_EVENT_INIT) || e.type==(JS_EVENT_AXIS | JS_EVENT_INIT));

   /* Iniciando secuencia */

   puts("Ya puedes iniciar secuencia");

   fread(&e,sizeof(struct js_event),1,fd);      

   /* Establecer rutina para SIGINT (control-c) para acabar */

   signal(SIGINT,acabar);

   for (;;)
    {   
        fread(&e,sizeof(struct js_event),1,fd);

        printf("%d (tipo)\n%d (numero)\n%d (valor)\n",e.type,e.number,e.value);
        fprintf(fc,"%d\n%d\n%d\n\n",e.type,e.number,e.value);
        
        puts("Haz el siguiente movimiento o control-c para acabar");
    }
 }


void acabar(int sig)
 {
   puts("Grabando fichero de configuracion");
   fclose(fc);
   puts("Cerrando dispositivo");
   fclose(fd);
   puts("Saliendo...");
   exit(0);
 }
