#include <stdio.h>
#include <string.h>
#include <stdlib.h>
                      
#include <linux/joystick.h>

/* Interprete de comandos a traves de un joystick v0.9p */
/* de El Presi [Enrique D. Bosch] (presi@euibbs.upv.es) */
/* la licencia de esto es la (GNU) GPL, mas info: www.fsf.org */

#define NPARAM 256          /* Numero de parametros (valores) maximos */
                            /* de las secuencias secuencias */
#define NPARAMM1 NPARAM-1   /* Numero de parametros menos 1 */
                            /* Numero de secuencias maximas = NPARAMM1 / 3 */
                            /* 3 valores por secuencia */

int main(int argc,char *argv[])
 {
   FILE *fd,*fc;
   struct js_event e;
   short int l[NPARAM], i, x;
   char aux[256],nomfc[256],disp[256],comando[256];

    /* Mensajes de version y ayuda */

   if (argc==2 && argv[1][0]=='-')
    {
      if (argv[1][1]=='v')
        {
          puts("joysh 0.9p");
          return 0;
        }
      if (argv[1][1]=='h')
        {
          puts("Utilizacion: joysh [fichero de configuracion]");
          return 0;
        }
    }  

    /* Determinar fichero de configuracion */

   if (argc>1) strcpy(nomfc,argv[1]);
          else strcpy(nomfc,"/etc/joysh.conf");
          
   if ( (fc = fopen(nomfc,"rb"))==NULL )
     {
       fputs("joysh: no se ha podido abrir fichero configuracion\n",stderr);
       return 1;
     }

   /* Interpretar fichero de configuracion */
   
   do        /* Extraer dispositivo */
    {
      fgets(aux,255,fc);
      if (aux[0]!='#' && aux[0]!=' ' && aux[0]!='\n')
         { 
           sscanf(aux,"%255s\n",disp);
           break;
         }
    } while (!feof(fc));

   do       /* Extraer comando */
    {
      fgets(comando,255,fc);
      if (comando[0]!='#'  && comando[0]!=' ' && comando[0]!='\n') break;
      
    } while (!feof(fc));

            /* Extraer secuencias */
    
   for (i = 0; !feof(fc) && i<NPARAMM1; i++)
      {
        fgets(aux,255,fc);
        if (aux[0]!='#'  && aux[0]!=' ' && aux[0]!='\n') sscanf(aux,"%d\n",l+i);
        else i--;
      }
   fclose(fc);

   i -= 2;

      /* Captura de eventos del joystick */

   if ( (fd = fopen(disp,"rb"))==NULL )
     {
       fputs("joysh: no se ha podido abrir fichero de dispositivo\n",stderr);
       return 1;
     }
   
      /* Captura de datos iniciales */
   
   do fread(&e,sizeof(struct js_event),1,fd);
   while ( e.type==(JS_EVENT_BUTTON | JS_EVENT_INIT) || e.type==(JS_EVENT_AXIS | JS_EVENT_INIT));

      /* Bucle de captura y comprobacion de secuencia */
   
   for(;;)
    {  
       for (x = 0; x<=i; x += 3)
        {
          fread(&e,sizeof(struct js_event),1,fd);
          if (e.type!=l[x] || e.number!=l[x+1] || e.value!=l[x+2]) x = -3;
        }
       system(comando);
    }
 }
